{$APPTYPE Console}
{$I-}

program NCMIDOFF;

Uses
  SysUtils;

const
  NoInput   = 1;                     { Errorcodes fr Fehlermeldungen }
  NoBak     = 2;
  NoResult  = 3;
  EParamNr  = 5;
  EPFormat  = 6;
  MoreMatch = 7;
  LessMatch = 8;

  MIDLen   = 13;                    { Lnge des Vergleich-Strings }
  MessageID : String[MIDLen] = 'Message-ID: '#0;    { danach suchen }
  XMessyID = 'X-Messy-ID';
  InFileN  = 'netscape.exe';        { Name der Originaldatei (fix) }
  OutfileN = InfileN + '.bak';      { Name der Backupdatei (fix) }

Var
  Buf,Pos1,Pos2 : PChar;            { Pointer fr Buffer und Suche }
  Memory      : Integer;            { Dateigre = Buffergre }
  TargetPatch : Integer;            { Nummer des zu patchenden Strings }
  InFile      : File;               { Dateivariablen fr NC und Backup }

Procedure XHalt(ECode: Integer);
  begin
    Halt (ECode);
  end;
Procedure Usage;
  begin
    Writeln;
    Writeln('Usage: "',ParamStr(0),'" [Patch-Nr.]');
    Writeln('  Patch-Nr.: Nummer des zu veraendernden Strings.');
    Writeln('             Normalerweise gibt es nur einen Treffer.');
    Writeln('             Deswegen wird ohne Parameter "1" angenommen.');
    Writeln;
    Writeln('Aktueller Aufruf war: "',ParamStr(0),'" ',ParamStr(1));
  end;
  
Procedure GetTarget;                { Parameter "auswerten" }
  begin
    Case ParamCount of
      0:   TargetPatch := 1;        { kein Parameter ::= 1. Treffer patchen }
      1:   begin                    { ein Parameter }
            try
              TargetPatch := StrToInt(ParamStr(1));     { auswerten }
            except
              on EConvertError do                       { bei Fehler }
                begin  usage;  XHalt(EPFormat);  end;   { abbrechen }
            end;
           end;
      Else begin                    { mehr Parameter }
            usage;
            XHalt (EParamNr);       { abbrechen }
           end;
    end;
  end;

Procedure SaveNC;                   { Programm Netscape.exe wieder speichern }
  Var FResult : Integer;            { File-I/O Result-Zhler }
  begin
    ReWrite (InFile, 1);                            { Datei lschen }
    BlockWrite (InFile, Buf^, Memory, FResult);     { neu schreiben }
    Close (InFile);                                 { schlieen }
    If FResult<Memory Then                          { dabei Fehler? }
      begin
       FreeMem(Buf, Memory);                        { Buffer freigeben }
       Writeln('Datei ',InFileN,' nicht erfolgreich geschrieben!');
       XHalt (NoResult);                            { Ende mit Errorcode }
      end;
  end;

Procedure LoadNC;                   { Programm Netscape.exe laden und sichern }
  Var FResult : Integer;            { File-I/O Result-Zhler }
  begin
    AssignFile(Infile,  InFileN);                   { Dateinamen zuordnen }
    ReSet (InFile, 1);                              { Original vorbereiten }
    Memory := FileSize(InFile);                     { Dateigre ermitteln }
    If Memory<=0 Then
      begin
       Close (InFile);                              { und schlieen }
       Writeln('Datei ',InFileN,' nicht vorhanden!');
       XHalt (NoInput);                            { Ende mit Errorcode }
      end;
    GetMem (Buf, Memory);                           { Speicher anfordern }
    BlockRead (InFile, Buf^, Memory, FResult);      { Datei lesen }
    Close (InFile);                                 { und schlieen }
    If FResult<Memory Then                          { bei Fehler }
      begin
       FreeMem(Buf, Memory);                        { Buffer freigeben }
       Writeln('Datei ',InFileN,' nicht lesbar!');
       XHalt (NoInput);                            { Ende mit Errorcode }
      end;
    Rename (InFile, OutFileN);                      { Rename to Backup }
    If IOResult<>0 Then
      begin
       FreeMem(Buf, Memory);                        { Buffer freigeben }
       Writeln('Backup-Datei ',OutFileN,' nicht schreibbar!');
       XHalt (NoBak);                               { Ende mit Errorcode }
      end;
    AssignFile(Infile,  InFileN);                   { Dateinamen neu zuordnen }
  end;

Procedure Patch;                    { Durchfhrung der Patches }
  Var i,j     : Integer;            { Zhler fr Fortschritt }
      Matches : Integer;            { und Treffer }
  begin
    Matches := 0;       { Noch keine Treffer }
    Pos1 := Buf;
    i := 2;             { Das 'MZ' am Anfang jeder Exe gleich berspringen }
    Inc(Pos1,i);
    While (i<Memory-MIDLen) Do      { ganzen Buffer durchsuchen }
      begin
       If (Pos1^='M') Then                  { erstmal nach dem 'M' suchen }
         begin
          Pos2 := Pos1;                     { bei Treffern }
          Dec(Pos2);
          If (Pos2^<#32) Then               { davor kein Character }
            begin
             Inc(Pos2,2);
             j :=2;
             While (j<=MIDLen) Do           { weiteren String vergleichen }
               begin
                If (Pos2^<>MessageID[j])
                  Then  break               { pat nicht, also raus }
                  Else  Inc(Pos2);          { weiter testen }
                Inc(j);
               end;
             If (j>MIDLen) Then             { hatte gepat! }
               begin
                Inc(Matches);               { noch ein Treffer }
                If Matches=TargetPatch      { Treffer ndern }
                  Then  Move(XMessyID,Pos1^,Length(XMessyID));
               end
             Else
               begin
                Pos1 := Pos2;               { gleich ab hier weiter suchen }
                Inc(i, j-1);                { denn ein 'M' war ja nicht }
                Continue;                   { enthalten }
               end;
            end;
         end;
       Inc(Pos1);
       Inc(i);
      end;
    Writeln (Matches,' Treffer fuer "',MessageID,'" gefunden.');
    If (Matches>1) and (ParamCount=0) Then
      begin
       Usage;
       XHalt(MoreMatch);
      end;
    If (Matches<TargetPatch) Then
      begin
       Usage;
       XHalt(LessMatch);
      end;
  end;

begin
  GetTarget;        { Parameter auswerten }
  LoadNC;           { Netscape.exe laden in dynamischen Speicher }
  Patch;            { String suchen und verndern }
  SaveNC;           { bei Erfolg speichern }
  XHalt (0);        { Fin }
end.
